package edu.swe622.fers.register;

import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Vector;

import edu.swe622.fers.util.ServiceUtil;
import org.uddi4j.datatype.Name;

public class ServicePublisher {
	private static String PUBLISHER_SERVICES = "publisher";
	private static String SERVICES_2_PUBLISH = "services.to.publish";
	private static String BISINESS_NAME = ".business_name";
	private static String TMODEL_NAME = ".t_model_name";
	private static String TMODEL_DOCUMENT = ".t_model_document";
	private static String ACCESS_POINT_URL = ".access_point_URL";
	private static String DESCRIPTION = ".description";
	private static String UDDI_USER_ID = "uddi.userId";
	private static String UDDI_PASSWORD = "uddi.password";
	private static String DEFAULT_USER = "juddi";
	private static String DEFAULT_PASSWORD = "juddi";
	
	ResourceBundle rb;
	
	public static void main(String []arg){
//		ResourceBundle rb = null;
//		//read the prop file
//		try{
//			rb = ResourceBundle.getBundle(PUBLISHER_SERVICES);
//		}catch(MissingResourceException mre){
//			System.out.println("Exception occured reading "+PUBLISHER_SERVICES+" "+mre.getMessage());
//		}
//		//look for service in the registry
//		String services2Publish = "";
//		try{
//			services2Publish = rb.getString(SERVICES_2_PUBLISH);
//			StringTokenizer stk = new StringTokenizer(services2Publish,",");
//			while(stk.hasMoreTokens()){
//				String serviceName = stk.nextToken();
//				String businessName = rb.getString(serviceName+BISINESS_NAME);
//				String tModelName = rb.getString(serviceName+TMODEL_NAME);
//				String tModelDocument = rb.getString(serviceName+TMODEL_DOCUMENT);
//				String accessPointURL = rb.getString(serviceName+ACCESS_POINT_URL);
//				String description = rb.getString(serviceName+DESCRIPTION);
//				
//				ServiceUtil.setupProxy(rb.getString(UDDI_USER_ID), rb.getString(UDDI_PASSWORD));
//				Vector<Name> nameVector = new Vector<Name>();
//				nameVector.add(new Name(serviceName));
//				Map serviceMap = ServiceUtil.findServiceByName(nameVector);
//				if(serviceMap.size()<=0){
//					ServiceUtil.publishService(serviceName, businessName, tModelName, tModelDocument, accessPointURL, description);
//					System.out.println("Service: "+serviceName+" registered successfully...");
//				}else{
//					System.out.println("service already registered....."+serviceName);
//					System.out.println("details: "+serviceMap);
//				}
//			}
//		}catch(MissingResourceException mre){
//			System.out.println("Exception occured reading "+PUBLISHER_SERVICES+" "+mre.getMessage());
//		}catch(Exception e){
//			System.out.println("Exception Occured while registering :"+e.getMessage());
//			e.printStackTrace();
//		}
		
		new ServicePublisher().publish(PUBLISHER_SERVICES);
		
		//if not found then publish service register
	}
	
	public void publish(String serviceName,String businessName,String tModelName,String tModelDocument,String accessPointURL,String description){
		ServiceUtil.setupProxy(DEFAULT_USER, DEFAULT_PASSWORD);
		Vector<Name> nameVector = new Vector<Name>();
		nameVector.add(new Name(serviceName));
		Map serviceMap = ServiceUtil.findServiceByName(nameVector);
		if(serviceMap.size()<=0){
			ServiceUtil.publishService(serviceName, businessName, tModelName, tModelDocument, accessPointURL, description);
			System.out.println("Service: "+serviceName+" registered successfully...");
		}else{
			System.out.println("service already registered....."+serviceName);
			System.out.println("details: "+serviceMap);
		}
	} 
	
	
	public void publish(String properties){
		ResourceBundle rb = null;
		//read the prop file
		try{
			rb = ResourceBundle.getBundle(PUBLISHER_SERVICES);
		}catch(MissingResourceException mre){
			System.out.println("Exception occured reading "+PUBLISHER_SERVICES+" "+mre.getMessage());
		}
		//look for service in the registry
		String services2Publish = "";
		try{
			services2Publish = rb.getString(SERVICES_2_PUBLISH);
			StringTokenizer stk = new StringTokenizer(services2Publish,",");
			while(stk.hasMoreTokens()){
				String serviceName = stk.nextToken();
				String businessName = rb.getString(serviceName+BISINESS_NAME);
				String tModelName = rb.getString(serviceName+TMODEL_NAME);
				String tModelDocument = rb.getString(serviceName+TMODEL_DOCUMENT);
				String accessPointURL = rb.getString(serviceName+ACCESS_POINT_URL);
				String description = rb.getString(serviceName+DESCRIPTION);
				publish(serviceName, businessName, tModelName, tModelDocument, accessPointURL, description);
			}
		}catch(MissingResourceException mre){
			System.out.println("Exception occured reading "+PUBLISHER_SERVICES+" "+mre.getMessage());
		}catch(Exception e){
			System.out.println("Exception Occured while registering :"+e.getMessage());
			e.printStackTrace();
		}
	}

}
