package edu.swe622.fers.service;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Vector;

import edu.swe622.fers.model.Location;
import edu.swe622.fers.model.Sensor;
import edu.swe622.fers.util.ServiceUtil;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ServiceContext;

public class FireMonitoringService {
	
	private static final String NORMALCY = "NORMALCY";

	private static final String ALARM = "ALARM";

	private static final int STATUS_NORMAL = 0;

	private static final int STATUS_ALARMED = 1;

	public static final String FIRE_SPRINKLER = "FIRE_SPRINKLER";

	public static final String SMOKE_DETECTOR = "SMOKE_DETECTOR";

	ArrayList<String> schools;
	
	private boolean dispatched = false;
	private boolean sentSOS =false;
	private boolean alramTriggered = false;
	private boolean turnOnSpinklers = false;
	
	HashMap<String,String> uddiMap = new HashMap<String,String>();
	
	HashMap<String,HashMap<String,Sensor>> schoolSensorMap = 
		new HashMap<String, HashMap<String,Sensor>>(4);
	
	String engineDispatchName = "EngineDispatchService0";
	String ambulanceDispatName = "AmbulanceDispatchService0";
	
	Vector<String> serviceNames = new Vector<String>();
	public void monitorSensors(){
		
//		HashMap<String, HashMap<String,Sensor>> schoolMap = new HashMap<String, HashMap<String,Sensor>>();
//		Vector<String> serviceNames = new Vector<String>();
		for (String string : schools) {
			serviceNames.add(string);
		}
		Map servicemap = ServiceUtil.findServiceByName(serviceNames);
		
		System.out.println("Availabel Services:"+servicemap);
		
	}
	//Update the sensorsMap
	private synchronized void updateSensorMap(Sensor sensor){
//		if(schoolSensorMap==null)
//			schoolSensorMap = new HashMap<String,HashMap<String,Sensor>>();
		HashMap<String,Sensor> tempMap= schoolSensorMap.get(sensor.getSchoolId());
		if(tempMap==null)
			tempMap = new HashMap<String,Sensor>();
		tempMap.put(sensor.getSensorId(),sensor);
		schoolSensorMap.put(sensor.getSchoolId(), tempMap);
		System.out.println("Total Sensors :"+tempMap.size());
	}
	
	
	public void updateStatus(Sensor sensor){
		
		//add the sensor reported
		System.out.println("triggeredSensor:"+sensor.getSensorId());
		updateSensorMap(sensor);
		int status = sensor.getStatus();
		if(sensor.getType().equals(SMOKE_DETECTOR)){
			
			switch(status){
			case STATUS_ALARMED:
				triggerAlarm(sensor);
				break;
			case STATUS_NORMAL:
				System.out.println("STATUS_NORMAL--->"+alramTriggered);
				if(alramTriggered){
					//checkAllTurnedOff
					if(isAllTheTriggeredSensorTurnedOff(sensor.getSchoolId())){
						//if yes ask to return dispatch by passing schoolId.
						dispatched = false;
						alramTriggered = false;
						//send normalcy
						System.out.println("Normalcy message sent....");
						new MonitorThread(sensor,ambulanceDispatName,NORMALCY).start();
						new MonitorThread(sensor,engineDispatchName,NORMALCY).start();
//						sendNormalcy(sensor, ambulanceDispatName, null);
//						sendNormalcyEngine(sensor, engineDispatchName, null);
						
						sentSOS = false;
						if(!turnOnSpinklers)
							turnOffAllNearSprinklers(sensor);
					}
				}
				break;
			default://do nothing
			}
			//check any other sensors that reported fire.
			//set already dispatch flag
		}else if(sensor.getType().equals(FIRE_SPRINKLER)){
			switch(status){
				case 0:
					//do nothing
					break;
				case 1:
					if(!turnOnSpinklers)
						turnOnAllNearSprinklers(sensor);
					break;
				default:
					//doNothing
			}
		}else throw new ApplicationExcpetion("Wrong type of Sensor "
				+sensor.getType()+ "at school "+sensor.getSchoolId());
	}
	
	private void turnOnAllNearSprinklers(Sensor sensor) {
		
//		HashMap<String,Sensor> sensorsTriggered = new HashMap<String,Sensor>();
//		HashMap<String,Sensor> sensors = schoolSensorMap.get(sensor.getSchoolId());
//		if(sensors==null)
//			sensors = new HashMap<String,Sensor>();
//		Iterator<Sensor> iter0 = sensors.values().iterator();
//		Sensor tempSensor = null;
//		while(iter0.hasNext()){
//			tempSensor = iter0.next();
//			if(tempSensor.getType().equals(FIRE_SPRINKLER) && 
//					isNearTo(sensor.getLocation(),tempSensor.getLocation())){
//				//Call SensorService and turn on the sprinkler by passing sensorId
//				turnOnSensor(tempSensor.getSensorId());
//			}
//		}
		System.out.println("Calling School");
		String schooldId = sensor.getSchoolId();
//		String uri = "http://localhost:8080/SchoolServiceWEB/services/";
		String endPoint = getEndPoint(schooldId);//uri+schooldId;//
		System.out.println("endPoint:"+endPoint);
		SchoolServiceStub stub;
		try {
			stub = new SchoolServiceStub(endPoint);
			stub.turnOnAllSprinklers();
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("sprinklers successfully truned on!");
		turnOnSpinklers=true;
	}
	
	private void turnOffAllNearSprinklers(Sensor sensor) {
		
//		HashMap<String,Sensor> sensors = schoolSensorMap.get(sensor.getSchoolId());
//		Iterator<Sensor> iter0 = sensors.values().iterator();
//		Sensor tempSensor = null;
//		while(iter0.hasNext()){
//			tempSensor = iter0.next();
//			if(tempSensor.getType().equals(FIRE_SPRINKLER)){
//				//Call SensorService and turn off all the sprinklers sensorId
//			if(turnOnSpinklers)
//				turnOffSensor(tempSensor.getSensorId());
//			}
//		}
//		turnOnSpinklers=true;
		
		System.out.println("Calling School");
		String schooldId = sensor.getSchoolId();
//		String uri = "http://localhost:8080/SchoolServiceWEB/services/";
		String endPoint = getEndPoint(schooldId);//uri+schooldId;//
		System.out.println("endPoint:"+endPoint);
		SchoolServiceStub stub;
		try {
			stub = new SchoolServiceStub(endPoint);
			stub.turnOffAllSprinklers();
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("sprinklers successfully truned on!");
		turnOnSpinklers=false;
	}
	
	private boolean isNearTo(Location loc1,Location loc2){
		return true;
	}
	
	private void triggerAlarm(Sensor sensor) {
		if(!alramTriggered) alramTriggered = true;
		//remove flag check and send the sensor every time
//		if(!dispatched){
			//dispatch service
			System.out.println("Dispatch Service...");
			
//			sendDispatchRequestEngine(sensor,engineDispatchName);
			new MonitorThread(sensor,engineDispatchName,ALARM).start();
			dispatched = true;
//		}
		System.out.println("SOS");
		//one SOS the
		if(!sentSOS){
			if(getTriggeredSensorList(sensor.getSchoolId()).size()>1){
				//sendSOS
				System.out.println("Send SOS");
				new MonitorThread(sensor,ambulanceDispatName,ALARM).start();
//				sendDispatchAmbulance(sensor,ambulanceDispatName);
				sentSOS = true;
				//turn On FireSpinkler Near to the smoke detector
				turnOnSpinklers=true;
				turnOnAllNearSprinklers(sensor);
			}
		}
	}
	private void sendDispatchRequestEngine(Sensor sensor,String serviceName) {
//		ServiceUtil.setupProxy("juddi", "juddi");
//		System.out.println("ServiceName in getEndPoint:"+serviceName);
//		Map accessPoints = ServiceUtil.getServiceAccessPoints(serviceName);
//		System.out.println("ServiceName:"+accessPoints);
//        String endPoint =  (String)accessPoints.keySet().iterator().next();
		try {
			EngineDispatchServiceStub stub = new EngineDispatchServiceStub("http://localhost:8080/EngineDispatchServiceWEB/services/"+serviceName);
//			EngineDispatchServiceStub stub = new EngineDispatchServiceStub(getEndPoint(serviceName));
			EngineDispatchServiceStub.RequestEngineDispatch requestEngineDispatch2 = new EngineDispatchServiceStub.RequestEngineDispatch();
			EngineDispatchServiceStub.Sensor tempSensor = new EngineDispatchServiceStub.Sensor();
			EngineDispatchServiceStub.Location location = new EngineDispatchServiceStub.Location();
			location.setCordX(sensor.getLocation().getCordX());
			location.setCordY(sensor.getLocation().getCordY());
			tempSensor.setLocation((location));
			tempSensor.setSensorId(sensor.getSensorId());
			tempSensor.setSchoolId(sensor.getSchoolId());
			tempSensor.setNearestFireStation(sensor.getNearestFireStation());
			tempSensor.setStatus(sensor.getStatus());
			tempSensor.setType(sensor.getType());
			requestEngineDispatch2.setNewSensor(tempSensor);
			stub.requestEngineDispatch(requestEngineDispatch2);
			System.out.println("request sent.....");
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void sendNormalcy(Sensor sensor,String serviceName) {
//		ServiceUtil.setupProxy("juddi", "juddi");
		System.out.println("ServiceName in getEndPoint:"+serviceName);
//		Map accessPoints = ServiceUtil.getServiceAccessPoints(serviceName);
//		System.out.println("ServiceName:"+accessPoints);
//        String endPoint =  (String)accessPoints.keySet().iterator().next();
		try {
			AmbulanceDispatchServiceStub stub = new AmbulanceDispatchServiceStub("http://localhost:8080/AmbulanceDispatchServiceWEB/services/"+serviceName);
//			EngineDispatchServiceStub stub = new EngineDispatchServiceStub(getEndPoint(serviceName));
			AmbulanceDispatchServiceStub.RequestEngineDispatch requestEngineDispatch2 = new AmbulanceDispatchServiceStub.RequestEngineDispatch();
			AmbulanceDispatchServiceStub.NormalcyMessage normalcy= new AmbulanceDispatchServiceStub.NormalcyMessage();
			stub.normalcyMessage(normalcy);
			System.out.println("request sent.....");
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void sendNormalcyEngine(Sensor sensor,String serviceName) {
//		ServiceUtil.setupProxy("juddi", "juddi");
		System.out.println("ServiceName in getEndPoint:"+serviceName);
//		Map accessPoints = ServiceUtil.getServiceAccessPoints(serviceName);
//		System.out.println("ServiceName:"+accessPoints);
//        String endPoint =  (String)accessPoints.keySet().iterator().next();
		try {
			EngineDispatchServiceStub stub = new EngineDispatchServiceStub("http://localhost:8080/EngineDispatchServiceWEB/services/"+serviceName);
//			EngineDispatchServiceStub stub = new EngineDispatchServiceStub(getEndPoint(serviceName));
//			EngineDispatchServiceStub.RequestEngineDispatch requestEngineDispatch2 = new AmbulanceDispatchServiceStub.RequestEngineDispatch();
			EngineDispatchServiceStub.NormalcyMessage normalcy= new EngineDispatchServiceStub.NormalcyMessage();
			normalcy.setNewSchool(sensor.getSchoolId());
			stub.normalcyMessage(normalcy);
			System.out.println("request sent.....");
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	private void sendDispatchAmbulance(Sensor sensor,String serviceName) {
//		ServiceUtil.setupProxy("juddi", "juddi");
		System.out.println("ServiceName in getEndPoint:"+serviceName);
//		Map accessPoints = ServiceUtil.getServiceAccessPoints(serviceName);
//		System.out.println("ServiceName:"+accessPoints);
//        String endPoint =  (String)accessPoints.keySet().iterator().next();
		try {
			AmbulanceDispatchServiceStub stub = new AmbulanceDispatchServiceStub("http://localhost:8080/AmbulanceDispatchServiceWEB/services/"+serviceName);
//			EngineDispatchServiceStub stub = new EngineDispatchServiceStub(getEndPoint(serviceName));
			AmbulanceDispatchServiceStub.RequestEngineDispatch requestEngineDispatch2 = new AmbulanceDispatchServiceStub.RequestEngineDispatch();
			AmbulanceDispatchServiceStub.Sensor tempSensor = new AmbulanceDispatchServiceStub.Sensor();
			AmbulanceDispatchServiceStub.Location location = new AmbulanceDispatchServiceStub.Location();
			location.setCordX(sensor.getLocation().getCordX());
			location.setCordY(sensor.getLocation().getCordY());
			tempSensor.setLocation(location);
			tempSensor.setSensorId(sensor.getSensorId());
			tempSensor.setSchoolId(sensor.getSchoolId());
			tempSensor.setNearestFireStation(sensor.getNearestFireStation());
			tempSensor.setStatus(sensor.getStatus());
			tempSensor.setType(sensor.getType());
			requestEngineDispatch2.setNewSensor(tempSensor);
			stub.requestEngineDispatch(requestEngineDispatch2);
			System.out.println("request sent.....");
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


	//Get all the list of smoke detectors the are triggered
	private HashMap<String,Sensor> getTriggeredSensorList(String shcoolId){
		HashMap<String,Sensor> sensorsTriggered = new HashMap<String,Sensor>();
		HashMap<String,Sensor> sensors = schoolSensorMap.get(shcoolId);
		if(sensors==null)
			sensors = new HashMap<String,Sensor>();
		Iterator<Sensor> iter0 = sensors.values().iterator();
		Sensor sensor = null;
		while(iter0.hasNext()){
			 sensor = iter0.next();
			if(sensor.getStatus()==STATUS_ALARMED && sensor.getType().equals(SMOKE_DETECTOR)){
				sensorsTriggered.put(sensor.getSensorId(),sensor);
			}
		}
		return sensorsTriggered;
	}
	
	
	//though most of the code is duplicated this will scale much better.
	private boolean isAllTheTriggeredSensorTurnedOff(String shcoolId){
		HashMap<String,Sensor> sensors = schoolSensorMap.get(shcoolId);
		Iterator<Sensor> iter0 = sensors.values().iterator();
		Sensor sensor = null;
		while(iter0.hasNext()){
			 sensor = iter0.next();
			if(sensor.getStatus()==STATUS_ALARMED && sensor.getType().equals(SMOKE_DETECTOR)){
				return false;
			}
		}
		return true;
	}
	
	private ServiceContext serviceContext;  
	   
    public void init(ServiceContext serviceContext) {  
        this.serviceContext = serviceContext;  
        schools = (ArrayList<String>)serviceContext.getAxisService().getParameterValue("schools");
        System.out.println("Schools:"+schools);
    }  
    
    private void turnOnSensor(String name){
    	String endPoint = getEndPoint(name);
    	SensorServiceStub stub;
		try {
			stub = new SensorServiceStub(endPoint);
			stub.turnOnSensor();
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    }
	public String getEndPoint(String serviceName) {
		String endPoint = uddiMap.get(serviceName);
		if(endPoint!=null){
			System.out.println("endPoint:"+endPoint);
			return endPoint;
		}else{
			ServiceUtil.setupProxy("juddi", "juddi");
			System.out.println("ServiceName in getEndPoint:"+serviceName);
			Map accessPoints = ServiceUtil.getServiceAccessPoints(serviceName);
			System.out.println("ServiceName:"+accessPoints);
	        endPoint =  (String)accessPoints.keySet().iterator().next();
	        uddiMap.put(serviceName, endPoint);
	        System.out.println("endPoint:"+endPoint);
	        return endPoint;
		}
		
		
	}
    private void turnOffSensor(String name){
    	String endPoint = getEndPoint(name);
    	SensorServiceStub stub;
		try {
			stub = new SensorServiceStub(endPoint);
			stub.turnOffSensor();
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    	
    }
    
    class MonitorThread extends Thread{
    	Sensor sensor;
    	String dispatchName;
    	String msgType;
    	
    	MonitorThread(Sensor sensor,String sEngineDispatchName,String sMsgType){
    		this.sensor = sensor;
    		dispatchName = engineDispatchName;
    		msgType = sMsgType;
    	}
    	public void run(){
    		System.out.println("running thread");
    		if(msgType.equals(ALARM)){
	    		if(dispatchName.equals(engineDispatchName))
	    			sendDispatchRequestEngine(sensor,dispatchName);
	    		else
	    			sendDispatchAmbulance(sensor,dispatchName);
    		}else if(msgType.equals(NORMALCY)){
    			
    			if(dispatchName.equals(engineDispatchName))
    				sendNormalcyEngine(sensor,dispatchName);
	    		else
	    			sendNormalcy(sensor,dispatchName);
    		}
    	}
    }
}
