package guifers.resources;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.jms.MessageListener;
import javax.jms.Message;
import javax.jms.TextMessage;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.MissingResourceException;
import java.util.Properties;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import javax.jms.DeliveryMode;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.Topic;
import org.apache.activemq.ActiveMQConnection;
import org.apache.activemq.ActiveMQConnectionFactory;


/**
 *
 * @author Zeynep
 */
public class FersGrid extends JFrame implements MessageListener{

    /**
     * @param args the command line arguments
     */
    //Dim 1 X coordinate
    //Dim 2 Y coordinate
    //Dim 3 vehicle type
    private HashMap<String,UIVehicle> vehicleMap = new HashMap<String,UIVehicle>();

    public static int[][][] vehicles;
    public static int[][][] buildings;
    public static int[][] alarm ;
    public int sizeX = 10;
    public int sizeY = 10;
    public Dimension frameDim;
    private Color gridColor = new Color(255,255,255);


    /***
     * JMS related stuff
     */

    private Session session;
    private Destination destination;
    private MessageProducer replyProducer;

    private boolean pauseBeforeShutdown;
    private boolean verbose = true;
    private int maxiumMessages;
    private String subject = "TOOL.DEFAULT";
    private boolean topic = false;
    private String user = ActiveMQConnection.DEFAULT_USER;
    private String password = ActiveMQConnection.DEFAULT_PASSWORD;
    private String url = ActiveMQConnection.DEFAULT_BROKER_URL;
//    private String url = "tcp://localhost:localhost:61616";
    private boolean transacted;
    private boolean durable=false;
    private String clientId;
    private int ackMode = Session.AUTO_ACKNOWLEDGE;
    private String consumerName = "James";
    private long sleepTime;
    private long receiveTimeOut;

    public FersGrid(){
        super();
        init();
    }

    public FersGrid(String title){
        super(title);
        init();
    }

    public FersGrid(String title,int sizeX,int sizeY){
        super(title);
        init(sizeX,sizeY);
    }

    public void init(){
        init(10,10);
    }

    public void init(int x, int y){
        sizeX = x;
        sizeY = y;
        frameDim = new Dimension(x*70,y*70);
        this.vehicles= new int[x][y][2];
        this.buildings= new int[x][y][2];
        this.alarm = new int[x][y];
        this.addComponentsToPane();
        this.setSize(frameDim);
        this.setTitle("FERS Grid");
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.pack();
        this.setVisible(true);
        
   }

   //TODO
    private void createVehicleMap(){
        //read the property file
        //
    }


    public Container addComponentsToPane() {
//        JFrame frame = new JFrame("GridBagLayoutDemo");
        JPanel container;
        int x = 60;
        int y = 60;

        Dimension dim = new Dimension(60, 60);
        container = new JPanel();
        container.setPreferredSize(new Dimension(sizeX*x,sizeY*y));
        JPanel panel;
        JTextArea text1;
        container.setLayout(new GridBagLayout());
        GridBagConstraints c = new GridBagConstraints();
//        panel = (JPanel)pane.getComponentAt(0,0);
        for (int i=0; i<sizeX; i++)
        {
            for (int j=0; j<sizeY; j++)
            {
                //Dimension sizes = new Dimension(50,50);
                panel = new JPanel();
                //System.out.println(alarm[i][j]);
                if (alarm[i][j]==1)
                    panel.setBackground(Color.RED);
                else
                panel.setBackground(Color.WHITE);
                panel.setBorder(BorderFactory.createEtchedBorder());
                String t=new String();
                t="";
                if (buildings[i][j][0]==1)
                    t+="H ";
                if (buildings[i][j][1]==1){
                    t+="S ";
                    panel.setBackground(gridColor);
                }
                if (vehicles[i][j][0]>0)
                    t+="\nA:"+vehicles[i][j][0];
                if (vehicles[i][j][1]>0)
                    t+="\nE:"+vehicles[i][j][1];
                                   
                text1 = new JTextArea(t);
                panel.setPreferredSize(new Dimension(60, 60));
               
                c.gridx = i;
                c.gridy = j;
                panel.add(text1);
                container.add(panel,c);
            }
        }

//        container.setPreferredSize(new Dimension(60*sizeX, 60*sizeY));
        return container;
    }

//    private static Container refreshView(FersGrid frame){
////        frame.addComponentsToPane();
////        return frame.getContentPane();
//    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        final FersGrid frame = new FersGrid("Test",10,10);
        frame.setPreferredSize(frame.frameDim);
        frame.pack();
        frame.setVisible(true);
        
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                Properties p= new Properties();
                try {
                    p.load(frame.getClass().getResourceAsStream("vehicle.properties"));
                    //ResourceBundle rb = ResourceBundle.getBundle("vehicle1");

                } catch (IOException e) {
                    e.printStackTrace();
                }
                
                String s2 = p.getProperty("schools");
                StringTokenizer st2 = new StringTokenizer(s2,",");
                while (st2.hasMoreTokens()) { 
                    String test=st2.nextToken();
                    int buildX= Integer.parseInt(p.getProperty(test+".X"));
                    int buildY= Integer.parseInt(p.getProperty(test+".Y"));
                    System.out.println(test);
                    frame.setSchool(buildX,buildY);
                } 
                
                //frame.setAlarm(7, 7);         
                
                String s = p.getProperty("vehicles");
                StringTokenizer st = new StringTokenizer(s,",");
                while (st.hasMoreTokens()) {
                    String vName=st.nextToken();
                    frame.initUI(vName);
                }     
                frame.setContentPane(frame.addComponentsToPane());
                frame.setPreferredSize(frame.frameDim);
                frame.pack();
                frame.setVisible(true);            
            }         
        });
        frame.receive();
    }
    /**
     * Initializes the UIVehicle
     * @param vehName
     */
    public void initUI(String vehName){
        //Read vehicle form prop file
        Properties pr= new Properties();
        try {
        pr.load(FersGrid.class.getResourceAsStream("vehicle.properties"));
        } catch (IOException e) {
        }

        int currx= Integer.parseInt(pr.getProperty(vehName+".currX"));
        int curry= Integer.parseInt(pr.getProperty(vehName+".currY"));
        int prevx= Integer.parseInt(pr.getProperty(vehName+".prevX"));
        int prevy= Integer.parseInt(pr.getProperty(vehName+".prevY"));
        String type= pr.getProperty(vehName+".type");

        //initilize the Hashmap
        UIVehicle newVehicle = new UIVehicle();
        newVehicle.setCurrX(currx);
        newVehicle.setCurrY(curry);
        newVehicle.setPrevX(0);
        newVehicle.setPrevY(0);
        newVehicle.setName(vehName);
        newVehicle.setType(type);
        vehicleMap.put(vehName,newVehicle);
        System.out.println("vehicle:"+newVehicle);


        updateVehicles(prevx,prevy,currx,curry,type.equals("A") ? 0 : 1);
        this.setContentPane(this.addComponentsToPane());
        this.setPreferredSize(this.frameDim);
        this.pack();
        this.setVisible(true);
    }

    public void updateSensorTrigger(int x, int y,int status){

        if(status==1)
          gridColor= new Color(255,0,0);
        else
             gridColor= new Color(255,255,255);
        setSchoolBGColor(x, y);
    }
    
    public void setSchoolBGColor(int x, int y){
         JPanel panel = (JPanel)this.getContentPane().getComponentAt(0,0).getComponentAt(x, y);
         panel.setBackground(gridColor);
    }

    
    public void updateUI(String vehName){


        UIVehicle vehicle = (UIVehicle)vehicleMap.get(vehName);
        updateVehicles(vehicle.getPrevX(),vehicle.getPrevY(),vehicle.getCurrX(),vehicle.getCurrY(),vehicle.getType().equals("A") ? 0 : 1);
        this.setContentPane(this.addComponentsToPane());
        this.setPreferredSize(this.frameDim);
        this.pack();
        this.setVisible(true);
    }

    private static void setAlarm(int a, int b) {
         alarm[a][b]=1;
    }

    public static void resetVehicles()
    {
        for (int i = 0; i < 10; ++i) {
            for (int j = 0; j < 10; ++j) {
                for (int k = 0; k < 2; ++k) {
                    vehicles[i][j][k] = 0;
                }
            }
        }
        //createAndShowGUI();
    }
    public static void resetBuildings()
    {
        for (int i = 0; i < 10; ++i) {
            for (int j = 0; j < 10; ++j) {
                for (int k = 0; k < 2; ++k) {
                    buildings[i][j][k] = 0;
                }
            }
        }
    }
    public static void setHospital(int a, int b)
    {
        buildings[a][b][0]=1;
    }
    public static void setSchool(int a, int b)
    {
        buildings[a][b][1]=1;
    }
    public static void updateVehicles(int a,int b, int c, int d, int v)
    {
        System.out.println("updating vehicle position: old "+a+"|"+b +" new c:"+c+"|"+d);
        if (a==-1)
            vehicles[c][d][v]+=1;
        else
        {
            System.out.println("updating vehicle position: old "+a+"|"+b +" new c:"+c+"|"+d);
            
            vehicles[c][d][v]+=1;
            vehicles[a][b][v]-=1;
        }
    }
    public void onMessage(Message message) {
        UIVehicle veh = new UIVehicle();
		try {
//            System.out.println("onMessage"+message);
            if (message instanceof TextMessage) {
            	TextMessage objMsg = (TextMessage)message;
                String msg = objMsg.getText();
                StringTokenizer st = new StringTokenizer(msg,"|");
                System.out.println("message:"+msg);
            	if(msg.indexOf("Sensor")==0){
                    st.nextToken();
                    int x = Integer.parseInt(st.nextToken());
                    int y = Integer.parseInt(st.nextToken());
                    int status = Integer.parseInt(st.nextToken());
                    updateSensorTrigger(x,y,status);
                }else{
                    while(st.hasMoreTokens()){
                        veh.setName(st.nextToken());
                        veh.setPrevX(Integer.parseInt(st.nextToken()));
                        veh.setPrevY(Integer.parseInt(st.nextToken()));
                        veh.setCurrX(Integer.parseInt(st.nextToken()));
                        veh.setCurrY(Integer.parseInt(st.nextToken()));
                        veh.setType(st.nextToken());
                    }
                    UIVehicle veh2 = (UIVehicle)vehicleMap.get(veh.getName());
    //                System.out.println( veh2.getType()+"|"+veh2.getCurrX()+"|"+veh2.getCurrY()+"|"+veh.getPrevX()+"|"+veh.getPrevY());
                    System.out.println("veh2:"+veh2);
                    if(veh2!=null){
                        if((veh2.getCurrX()==veh.getPrevX() && veh2.getCurrY() == veh.getPrevY())||
                                (veh2.getCurrX()==veh.getCurrX() && veh2.getCurrY() == veh.getCurrY() &&
                                veh2.getPrevX()==veh.getPrevX() && veh2.getPrevY() == veh.getPrevY())){
                            System.out.println("inside if ---");
                            vehicleMap.put(veh.getName(),veh);
    //                        System.out.println("VehicleItem:"+veh.toString());
                            updateUI(veh.getName());
                        }else{
                            System.out.println("No vehicle found.....");
                        }
                    }
                }
	            if (transacted) {
	                session.commit();
	            } else if (ackMode == Session.CLIENT_ACKNOWLEDGE) {
	                message.acknowledge();
	            }
            }
        } catch (JMSException e) {
            System.out.println("Caught: " + e);
            e.printStackTrace();
        } finally {
            if (sleepTime > 0) {
                try {
                    Thread.sleep(sleepTime);
                } catch (InterruptedException e) {
                }
            }
        }
	}
    public void receive() {
        try {
//            running = true;

            System.out.println("Connecting to URL: " + url);
            System.out.println("Consuming " + (topic ? "topic" : "queue") + ": " + subject);
            System.out.println("Using a " + (durable ? "durable" : "non-durable") + " subscription");

            ActiveMQConnectionFactory connectionFactory = new ActiveMQConnectionFactory(user, password, url);
            javax.jms.Connection connection = connectionFactory.createConnection();
            if (durable && clientId != null && clientId.length() > 0 && !"null".equals(clientId)) {
                connection.setClientID(clientId);
            }
//            connection.setExceptionListener(this);
            connection.start();

            session = connection.createSession(transacted, ackMode);
            destination = session.createQueue(subject);
            
            
            MessageConsumer consumer = null;
            consumer = session.createConsumer(destination);
            
//            System.out.println("Receiving msg ");
//            Message message = consumer.receive();
//            onMessage(message);
            consumer.setMessageListener(this);

        } catch (Exception e) {
            System.out.println("Caught: " + e);
            e.printStackTrace();
        }
    }
}


