package edu.swe622.fers.service;

import java.util.ResourceBundle;

import javax.xml.namespace.QName;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.description.AxisOperation;
import org.apache.axis2.description.AxisService;
import org.apache.axis2.engine.ServiceLifeCycle;

import edu.swe622.fers.model.Location;
import edu.swe622.fers.model.Sensor;
import edu.swe622.fers.model.XYLocation;
import edu.swe622.fers.util.BusinessUtilities;
import edu.swe622.fers.util.ServiceUtil;

public class SensorLifeCycle implements ServiceLifeCycle {

	
	private static final String NEAREST_FIRE_STATION = "nearestFireStation";
	private static String SENSOR_ID="sensorId";
	private static String SCHOOL_ID="schoolId";
	private static String TYPE = "type";
	private static String LOCATION_ID = "location.locationId";
	private static String LOCATION_LATITUDE = "location.latitude";
	private static String LOCATION_LONGITUDE = "location.longitude";
	
//	public void shutDown(ConfigurationContext arg0, AxisService arg1) {
		// TODO Auto-generated method stub

//	}

	public void startUp(ConfigurationContext configContext, AxisService service) {
		System.out.println("insidestartup");
		String serviceName = service.getName();
		System.out.println("ServiceName:"+serviceName);
		Sensor sensor = new Sensor();
		
		try {
			ResourceBundle rb = ResourceBundle.getBundle("sensors");
			Location location = new Location(Integer.parseInt(rb.getString(serviceName+"."+LOCATION_LATITUDE)),
					Integer.parseInt(rb.getString(serviceName+"."+LOCATION_LONGITUDE)));
//			location.setLocationId(rb.getString(serviceName+"."+LOCATION_ID));
//			location.setCordX(Double.parseDouble(rb.getString(serviceName+"."+LOCATION_LATITUDE)));
//			location.setCordY(Double.parseDouble(rb.getString(serviceName+"."+LOCATION_LONGITUDE)));
			
			sensor.setLocation(location);
//			System.out.println("sensor:"+sensor);
			sensor.setSensorId(rb.getString(serviceName+"."+SENSOR_ID));
			sensor.setSchoolId(rb.getString(serviceName+"."+SCHOOL_ID));
			sensor.setNearestFireStation(rb.getString(serviceName+"."+NEAREST_FIRE_STATION));
			sensor.setType(rb.getString(serviceName+"."+TYPE));
			
			service.addParameter("sensor", sensor);
			System.out.println("sensor:\n"+sensor);
			
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

public void shutDown(ConfigurationContext arg0, AxisService arg1) {
	// TODO Auto-generated method stub
	
}

}
