package edu.swe622.fers.service;

import java.util.HashMap;
import java.util.Map;

import org.apache.axis2.context.ServiceContext;

import edu.swe622.fers.model.Sensor;
import edu.swe622.fers.util.MQSender;
import edu.swe622.fers.util.ServiceUtil;

public class SensorService {
	Sensor sensor;
	private HashMap<String,String> uddiMap = new HashMap<String,String>();
	
	public Sensor getSensor(){
		return this.sensor;
	}
	
	public Sensor setSensor(){
		return this.sensor;
	}
	
	public void turnOffSensor(){
		sensor.setStatus(0);
		updateUI(sensor);
		publishStatusToFireStation();
	}
	
	public void turnOnSensor(){
		sensor.setStatus(1);
		System.out.println("Sensor turned on...."+sensor.getSensorId());
		updateUI(sensor);
		publishStatusToFireStation();
		
	}
	
	private void publishStatusToFireStation(){
		
		String serviceName = sensor.getNearestFireStation();
		System.out.println("Publishing to fire station: "+serviceName);
        try{
        	FireMonitoringServiceStub stub = new FireMonitoringServiceStub(getEndPoint(serviceName));
        	FireMonitoringServiceStub.Sensor tempSensor = new FireMonitoringServiceStub.Sensor();
        	FireMonitoringServiceStub.Location tempLocation = new FireMonitoringServiceStub.Location();
        	tempLocation.setCordX(sensor.getLocation().getCordX());
        	tempLocation.setCordY(sensor.getLocation().getCordY());
        	tempSensor.setLocation(tempLocation);
        	tempSensor.setNearestFireStation(sensor.getNearestFireStation());
        	tempSensor.setSchoolId(sensor.getSchoolId());
        	tempSensor.setSensorId(sensor.getSensorId());
        	tempSensor.setStatus(sensor.getStatus());
        	tempSensor.setType(sensor.getType());
        	FireMonitoringServiceStub.UpdateStatus updateStatus = new FireMonitoringServiceStub.UpdateStatus();
        	updateStatus.setSensor(tempSensor);
        	stub.updateStatus(updateStatus);
//        	ServiceFactory serviceFactory = ServiceFactory.newInstance();
//        	Service service = serviceFactory.createService(new URL(url), serviceQN);
          }catch(Exception e){
        	e.printStackTrace();
        }
		/* The "new URL(wsdlURL)" parameter is optional */
		
		
	}

	private String getEndPoint(String serviceName) {
		
//		String endPoint = uddiMap.get(serviceName);
//		System.out.println("Endpoint this time :"+endPoint);
//		if(endPoint!=null){
//			return endPoint;
//		}else{
//			ServiceUtil.setupProxy("juddi", "juddi");
//			Map services =  ServiceUtil.getServiceAccessPoints(serviceName);
//			System.out.println("Map: "+services );
//			endPoint= (String)services.keySet().iterator().next();
//			uddiMap.put(serviceName, endPoint);
//			return endPoint;
//		}
		return "http://localhost:8080/"+serviceName.substring(0,serviceName.length()-1)+"WEB/services/"+serviceName;
	}
	
	
	private ServiceContext serviceContext;
	public void init(ServiceContext serviceContext) {  
        this.serviceContext = serviceContext;  
        sensor = (Sensor)serviceContext.getAxisService()  
        .getParameterValue("sensor");
    }
	
	private void updateUI(Sensor sensor){
		String msgString = sensor.getSensorId()+"|"+
						   (int)sensor.getLocation().getCordX()+"|"+
						   (int)sensor.getLocation().getCordY()+"|"+
						   (int)sensor.getStatus();
		System.out.println("Sensor Service message:"+msgString);
		new MQSender().send(msgString);
	}
}
