package guifers;
/**
 * Redirects the System out to a Text Area
 * @author Krishna Rudravarjula
 */
import java.io.OutputStream;
import javax.swing.JTextArea;

/**
 * Output to Text Area
 */
public class TextAreaOutputStream extends OutputStream
{
  private static TextAreaOutputStream staticRef=null;

  /**
   * Set a single instance accesible via static methods
   */
  public static void setStaticOutput(Object jta)
  {
    staticRef=new TextAreaOutputStream((JTextArea) jta);
  }

  /**
   * Get a single instance accesible via static methods
   */
  public static TextAreaOutputStream getStaticOutput()
  {
    return staticRef;
  }

  /**
   * TextArea output destination
   */
  private JTextArea jta;

  /**
   * Constructor
   */
  public TextAreaOutputStream(Object jta)
  {
    this.jta=(JTextArea)jta;
  }

  /**
   * Method to write a byte subarray to the text area as a stream
   */
  public void write(byte[] buf, int off, int len)
  {
    jta.append(new String(buf,off,len));
  }

  /**
   * Method to write a byte array to the text area as a stream
   */
  public void write(byte b[])
  {
    jta.append(new String(b));
  }

  /**
   * Method to write a byte to the text area as a stream
   */
  public void write(int b)
  {
    byte ba[]=new byte[1];
    ba[0]=(byte)b;
    jta.append(new String(ba));
  }
}
